
# Alioth Display DCD+120 FPS

SKIPUNZIP=1

Dev_Feat_Dir="/system/product/etc/device_features"
Target_Dir="${MODPATH}$Dev_Feat_Dir"
System_Dir="${MODPATH}/system"
Indent="  "

ui_print "${Indent}Looking around..."

if [ -z "$BOOTMODE" -o "$BOOTMODE" != "true" ]; then
	ui_print "***"
	ui_print "${Indent}ERROR: You have to install this module"
	ui_print "${Indent}from the Magisk app,"
	ui_print "${Indent}not from Recovery!"
	ui_print "***"
	ui_print "${Indent}Aborting..."
	abort "***"
fi

if [ "$(getprop ro.product.product.name)" != 'alioth' ]; then
	ui_print "***"
	ui_print "${Indent}ERROR: This is not Xiaomi POCO F3 (alioth)!"
	ui_print "***"
	ui_print "${Indent}Aborting..."
	abort "***"
fi

if [ ! -d "$Dev_Feat_Dir" ]; then
	ui_print "***"
	ui_print "${Indent}ERROR: Directory"
	ui_print "${Indent}\"$Dev_Feat_Dir\""
	ui_print "${Indent}is not found!"
	ui_print "***"
	ui_print "${Indent}Aborting..."
	abort "***"
fi

unset Patching_Needed

for file in "$Dev_Feat_Dir"/*; do
	grep -qsF '<integer name="defaultFps">60</integer>' "$file" && Patching_Needed=true
	grep -qsF '<bool name="support_dc_backlight">false</bool>' "$file" && Patching_Needed=true
done

if [ -z "$Patching_Needed" ]; then
	ui_print "***"
	ui_print "${Indent}ERROR: Patterns not found,"
	ui_print "${Indent}nothing to patch!"
	ui_print "***"
	ui_print "${Indent}Aborting..."
	abort "***"
fi

ui_print "${Indent}Looks good."

ui_print "${Indent}Installing module..."

unzip -qoj "$ZIPFILE" 'module.prop' -d "$MODPATH" >&2

[ -d "$System_Dir" ] && rm -rf "$System_Dir"

ui_print "${Indent}${Indent}Patching files:"

for file in "$Dev_Feat_Dir"/*; do

	file_name="${file##*/}"

	unset Patching_Needed

	grep -qsF '<integer name="defaultFps">60</integer>' "$file" && Patching_Needed=true
	grep -qsF '<bool name="support_dc_backlight">false</bool>' "$file" && Patching_Needed=true

	if [ "$Patching_Needed" ]; then

		ui_print "${Indent}${Indent}${Indent}\"$file_name\""

		if [ ! -d "$Target_Dir" ]; then
			mkdir -p "$Target_Dir"
			[ -d "$System_Dir" ] && set_perm_recursive "$System_Dir" 0 0 0755 0755
		fi

		[ -d "$Target_Dir" ] && sed -re 's/<integer name="defaultFps">60<\/integer>/<integer name="defaultFps">120<\/integer>/' -re 's/<bool name="support_dc_backlight">false<\/bool>/<bool name="support_dc_backlight">true<\/bool>/' "$file" > "$Target_Dir/$file_name"
		[ -f "$Target_Dir/$file_name" ] && set_perm "$Target_Dir/$file_name" 0 0 0644

	fi

done
